Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 71)
+++ doc/groups.dox	(revision 50)
@@ -488,18 +488,18 @@
 @defgroup section_io Section readers and writers
 @ingroup lemon_io
-\brief Section readers and writers for LEMON Input-Output.
-
-This group describes section reader and writer classes that can be 
-attached to \ref LemonReader and \ref LemonWriter.
-*/
-
-/**
-@defgroup item_io Item readers and writers
+\brief Section readers and writers for lemon Input-Output.
+
+This group describes section readers and writers that can be attached to
+\ref LemonReader and \ref LemonWriter.
+*/
+
+/**
+@defgroup item_io Item Readers and Writers
 @ingroup lemon_io
-\brief Item readers and writers for LEMON Input-Output.
-
-This group describes reader and writer classes for various data types
-(e.g. map or attribute values). These classes can be attached to
-\ref LemonReader and \ref LemonWriter.
+\brief Item readers and writers for lemon Input-Output.
+
+The Input-Output classes can handle more data type by example
+as map or attribute value. Each of these should be written and
+read some way. The module make possible to do this.  
 */
 
Index: lemon/tolerance.h
===================================================================
--- lemon/tolerance.h	(revision 72)
+++ lemon/tolerance.h	(revision 49)
@@ -41,7 +41,7 @@
   ///as a result of a probably inexact computation.
   ///
-  ///This is an abstract class, it should be specialized for all 
-  ///numerical data types. These specialized classes like 
-  ///Tolerance<double> may offer additional tuning parameters.
+  ///This is an abstract class, it should be specialized for all numerical
+  ///data types. These specialized classes like \ref Tolerance<double>
+  ///may offer additional tuning parameters.
   ///
   ///\sa Tolerance<float>
@@ -118,5 +118,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -169,5 +169,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -220,5 +220,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -253,5 +253,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -276,5 +276,5 @@
   ///Unsigned integer specialization of Tolerance.
 
-  ///Unsigned integer specialization of Tolerance.
+  ///Unsigned integer specialization of \ref Tolerance.
   ///\sa Tolerance
   template<>
@@ -286,5 +286,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -320,5 +320,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -343,5 +343,5 @@
   ///Unsigned long integer specialization of Tolerance.
 
-  ///Unsigned long integer specialization of Tolerance.
+  ///Unsigned long integer specialization of \ref Tolerance.
   ///\sa Tolerance
   template<>
@@ -353,5 +353,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -378,5 +378,5 @@
   ///Long long integer specialization of Tolerance.
 
-  ///Long long integer specialization of Tolerance.
+  ///Long long integer specialization of \ref Tolerance.
   ///\warning This class (more exactly, type <tt>long long</tt>)
   ///is not ansi compatible.
@@ -390,5 +390,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -413,5 +413,5 @@
   ///Unsigned long long integer specialization of Tolerance.
 
-  ///Unsigned long long integer specialization of Tolerance.
+  ///Unsigned long long integer specialization of \ref Tolerance.
   ///\warning This class (more exactly, type <tt>unsigned long long</tt>)
   ///is not ansi compatible.
@@ -425,5 +425,5 @@
 
     ///\name Comparisons
-    ///See \ref lemon::Tolerance "Tolerance" for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{