Index: src/demo/Makefile.am
===================================================================
--- src/demo/Makefile.am	(revision 1387)
+++ src/demo/Makefile.am	(revision 1401)
@@ -2,5 +2,5 @@
 LDADD = $(top_builddir)/src/lemon/libemon.la
 
-EXTRA_DIST = sub_graph_wrapper_demo.dim
+EXTRA_DIST = sub_graph_adaptor_demo.dim
 
 noinst_PROGRAMS = \
@@ -9,5 +9,5 @@
 	graph_to_eps_demo \
 	min_route \
-	sub_graph_wrapper_demo
+	sub_graph_adaptor_demo
 
 if HAVE_GLPK
@@ -28,6 +28,6 @@
 min_route_SOURCES = min_route.cc
 
-sub_graph_wrapper_demo_SOURCES = \
-	sub_graph_wrapper_demo.cc \
+sub_graph_adaptor_demo_SOURCES = \
+	sub_graph_adaptor_demo.cc \
 	tight_edge_filter_map.h
 
Index: src/demo/sub_graph_adaptor_demo.cc
===================================================================
--- src/demo/sub_graph_adaptor_demo.cc	(revision 1401)
+++ src/demo/sub_graph_adaptor_demo.cc	(revision 1401)
@@ -0,0 +1,80 @@
+// -*- c++ -*-
+
+// Use a DIMACS max flow file as stdin.
+// sub_graph_adaptor_demo < dimacs_max_flow_file
+// This program computes a maximum number of edge-disjoint shortest paths
+// between s and t.
+
+#include <iostream>
+#include <fstream>
+
+#include <lemon/smart_graph.h>
+#include <lemon/dijkstra.h>
+#include <lemon/maps.h>
+#include <lemon/graph_adaptor.h>
+#include <lemon/dimacs.h>
+#include <lemon/preflow.h>
+#include <tight_edge_filter_map.h>
+
+using namespace lemon;
+
+using std::cout;
+using std::endl;
+
+int main()
+{    
+  typedef SmartGraph Graph;
+
+  typedef Graph::Edge Edge;
+  typedef Graph::Node Node;
+  typedef Graph::EdgeIt EdgeIt;
+  typedef Graph::NodeIt NodeIt;
+  typedef Graph::EdgeMap<int> LengthMap;
+
+  Graph g;
+  Node s, t;
+  LengthMap length(g);
+
+  readDimacs(std::cin, g, length, s, t);
+
+  cout << "edges with lengths (of form id, source--length->target): " << endl;
+  for(EdgeIt e(g); e!=INVALID; ++e) 
+    cout << " " << g.id(e) << ", " << g.id(g.source(e)) << "--" 
+	 << length[e] << "->" << g.id(g.target(e)) << endl;
+
+  cout << "s: " << g.id(s) << " t: " << g.id(t) << endl;
+
+  typedef Dijkstra<Graph, LengthMap> Dijkstra;
+  Dijkstra dijkstra(g, length);
+  dijkstra.run(s);
+
+  // This map returns true exactly for those edges which are 
+  // tight w.r.t the length funcion and the potential 
+  // given by the dijkstra algorithm.
+  typedef TightEdgeFilterMap<Graph, const Dijkstra::DistMap, LengthMap> 
+    TightEdgeFilter;
+  TightEdgeFilter tight_edge_filter(g, dijkstra.distMap(), length);
+
+//  ConstMap<Node, bool> const_true_map(true);
+  // This graph contains exaclty the tight edges.
+// typedef SubGraphAdaptor<Graph, ConstMap<Node, bool>, TightEdgeFilter> SubGW;
+  typedef EdgeSubGraphAdaptor<Graph, TightEdgeFilter> SubGW;
+  SubGW gw(g, tight_edge_filter);
+
+  ConstMap<Edge, int> const_1_map(1);
+  Graph::EdgeMap<int> flow(g, 0);
+  // Max flow between s and t in the graph of tight edges.
+  Preflow<SubGW, int, ConstMap<Edge, int>, Graph::EdgeMap<int> > 
+    preflow(gw, s, t, const_1_map, flow);
+  preflow.run();
+
+  cout << "maximum number of edge-disjoint shortest path: " 
+       << preflow.flowValue() << endl;
+  cout << "edges of the maximum number of edge-disjoint shortest s-t paths: " 
+       << endl;
+  for(EdgeIt e(g); e!=INVALID; ++e) 
+    if (flow[e])
+      cout << " " << g.id(e) << ", "
+	   << g.id(g.source(e)) << "--" 
+	   << length[e] << "->" << g.id(g.target(e)) << endl;
+}
Index: src/demo/sub_graph_adaptor_demo.dim
===================================================================
--- src/demo/sub_graph_adaptor_demo.dim	(revision 1401)
+++ src/demo/sub_graph_adaptor_demo.dim	(revision 1401)
@@ -0,0 +1,14 @@
+c LEMON max flow problem
+p max 7 9
+n 1 s
+n 7 t
+a 1 2 3
+a 1 3 2
+a 1 4 1
+a 2 5 3
+a 3 5 2
+a 3 7 5
+a 3 6 3
+a 4 6 1
+a 5 7 2
+a 6 7 4
Index: src/demo/sub_graph_wrapper_demo.cc
===================================================================
--- src/demo/sub_graph_wrapper_demo.cc	(revision 986)
+++ 	(revision )
@@ -1,80 +1,0 @@
-// -*- c++ -*-
-
-// Use a DIMACS max flow file as stdin.
-// sub_graph_wrapper_demo < dimacs_max_flow_file
-// This program computes a maximum number of edge-disjoint shortest paths
-// between s and t.
-
-#include <iostream>
-#include <fstream>
-
-#include <lemon/smart_graph.h>
-#include <lemon/dijkstra.h>
-#include <lemon/maps.h>
-#include <lemon/graph_wrapper.h>
-#include <lemon/dimacs.h>
-#include <lemon/preflow.h>
-#include <tight_edge_filter_map.h>
-
-using namespace lemon;
-
-using std::cout;
-using std::endl;
-
-int main()
-{    
-  typedef SmartGraph Graph;
-
-  typedef Graph::Edge Edge;
-  typedef Graph::Node Node;
-  typedef Graph::EdgeIt EdgeIt;
-  typedef Graph::NodeIt NodeIt;
-  typedef Graph::EdgeMap<int> LengthMap;
-
-  Graph g;
-  Node s, t;
-  LengthMap length(g);
-
-  readDimacs(std::cin, g, length, s, t);
-
-  cout << "edges with lengths (of form id, source--length->target): " << endl;
-  for(EdgeIt e(g); e!=INVALID; ++e) 
-    cout << " " << g.id(e) << ", " << g.id(g.source(e)) << "--" 
-	 << length[e] << "->" << g.id(g.target(e)) << endl;
-
-  cout << "s: " << g.id(s) << " t: " << g.id(t) << endl;
-
-  typedef Dijkstra<Graph, LengthMap> Dijkstra;
-  Dijkstra dijkstra(g, length);
-  dijkstra.run(s);
-
-  // This map returns true exactly for those edges which are 
-  // tight w.r.t the length funcion and the potential 
-  // given by the dijkstra algorithm.
-  typedef TightEdgeFilterMap<Graph, const Dijkstra::DistMap, LengthMap> 
-    TightEdgeFilter;
-  TightEdgeFilter tight_edge_filter(g, dijkstra.distMap(), length);
-
-//  ConstMap<Node, bool> const_true_map(true);
-  // This graph contains exaclty the tight edges.
-// typedef SubGraphWrapper<Graph, ConstMap<Node, bool>, TightEdgeFilter> SubGW;
-  typedef EdgeSubGraphWrapper<Graph, TightEdgeFilter> SubGW;
-  SubGW gw(g, tight_edge_filter);
-
-  ConstMap<Edge, int> const_1_map(1);
-  Graph::EdgeMap<int> flow(g, 0);
-  // Max flow between s and t in the graph of tight edges.
-  Preflow<SubGW, int, ConstMap<Edge, int>, Graph::EdgeMap<int> > 
-    preflow(gw, s, t, const_1_map, flow);
-  preflow.run();
-
-  cout << "maximum number of edge-disjoint shortest path: " 
-       << preflow.flowValue() << endl;
-  cout << "edges of the maximum number of edge-disjoint shortest s-t paths: " 
-       << endl;
-  for(EdgeIt e(g); e!=INVALID; ++e) 
-    if (flow[e])
-      cout << " " << g.id(e) << ", "
-	   << g.id(g.source(e)) << "--" 
-	   << length[e] << "->" << g.id(g.target(e)) << endl;
-}
Index: src/demo/sub_graph_wrapper_demo.dim
===================================================================
--- src/demo/sub_graph_wrapper_demo.dim	(revision 922)
+++ 	(revision )
@@ -1,14 +1,0 @@
-c LEMON max flow problem
-p max 7 9
-n 1 s
-n 7 t
-a 1 2 3
-a 1 3 2
-a 1 4 1
-a 2 5 3
-a 3 5 2
-a 3 7 5
-a 3 6 3
-a 4 6 1
-a 5 7 2
-a 6 7 4